c***********************************************************************
      DOUBLE PRECISION FUNCTION inlet(r,nx)
      include 'undefined.h'
      include 'physics.h'
      integer nx
      double precision r, pi, r0, u0, scale
      DOUBLE PRECISION PARDPR(100)
      h=1.d0/(nx-2)
      pi=4.d0*datan(1.d0)

      r0 = GP_DFETCH('radius',1.d0,'SEVERE')
      u0 = GP_DFETCH('liquid_velocity',1.d0,'SEVERE')


      scale = (1.0d0/vscale) * (tau/h)

      if (r.lt.(4./5.)*r0) then
        inlet = u0*scale
      elseif (r.le.r0) then
        inlet = 5.*u0*scale*(1.-r/r0)
      else 
        inlet=0.
      endif  

      return
      end
